--------------------------------------------------------------------------------
-- (c) by c't magazin 
--------------------------------------------------------------------------------
--
-- Design name : CT_Lab_FPGA
--
-- Filename : MUX_32.vhd
-- Version : 1.0
-- Date: 13.7.2008
--
-- Engineer : Klaus Philipp

--------------------------------------------------------------------------------
-- Frequency Counters Multiplexer
--
-- The multiplexer sends the values of the two 32-bit binary counters to
-- the output. This is controlled by the AB_SWICH signal.
--
--------------------------------------------------------------------------------
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--
library unisim;
use unisim.vcomponents.all;

entity MUX_32 is
   port ( CLK     : in    std_logic;
	       IN_A    : in    std_logic_vector (31 downto 0); 
          IN_B    : in    std_logic_vector (31 downto 0); 
          SEL_AB  : in    std_logic; 
          OUT_MUX : out std_logic_vector (31 downto 0));
end MUX_32;

architecture BEHAVIORAL of MUX_32 is

begin

  counter_mux : process(CLK, SEL_AB, IN_A, IN_B)
  begin
    if rising_edge (CLK)
	 then
		 if SEL_AB = '1' then
			 OUT_MUX <= IN_A;
		 else
			 OUT_MUX <= IN_B;
		 end if;
	 end if;
  end process counter_mux;

end BEHAVIORAL;
